
-- VHDL Test Bench Created from source file opb_xsb300_ak4565.vhd -- 20:41:48 09/28/2003
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE behavior OF testbench IS 

	COMPONENT opb_xsb300_ak4565
	PORT(
		opb_clk : IN std_logic;
		opb_rst : IN std_logic;
		opb_abus : IN std_logic_vector(31 downto 0);
		opb_be : IN std_logic_vector(3 downto 0);
		opb_dbus : IN std_logic_vector(31 downto 0);
		opb_rnw : IN std_logic;
		opb_select : IN std_logic;
		opb_seqaddr : IN std_logic;
		
		au_sdto0 : IN std_logic;          
		uio_dbus : OUT std_logic_vector(31 downto 0);
		uio_errack : OUT std_logic;
		uio_retry : OUT std_logic;
		uio_toutsup : OUT std_logic;
		uio_xferack : OUT std_logic;
		au_csn_n : OUT std_logic;
		au_bclk : OUT std_logic;
		au_mclk : OUT std_logic;
		au_lrck : OUT std_logic;
		au_sdti : OUT std_logic
		);
	END COMPONENT;

	SIGNAL opb_clk :  std_logic;
	SIGNAL opb_rst :  std_logic;
	SIGNAL opb_abus :  std_logic_vector(31 downto 0);
	SIGNAL opb_be :  std_logic_vector(3 downto 0);
	SIGNAL opb_dbus :  std_logic_vector(31 downto 0);
	SIGNAL opb_rnw :  std_logic;
	SIGNAL opb_select :  std_logic;
	SIGNAL opb_seqaddr :  std_logic;
	
	SIGNAL uio_dbus :  std_logic_vector(31 downto 0);
	SIGNAL uio_errack :  std_logic;
	SIGNAL uio_retry :  std_logic;
	SIGNAL uio_toutsup :  std_logic;
	SIGNAL uio_xferack :  std_logic;
	SIGNAL au_csn_n :  std_logic;
	SIGNAL au_bclk :  std_logic;
	SIGNAL au_mclk :  std_logic;
	SIGNAL au_lrck :  std_logic;
	SIGNAL au_sdti :  std_logic;
	SIGNAL au_sdto0 :  std_logic;
   
BEGIN

	uut: opb_xsb300_ak4565 PORT MAP(
		opb_clk => opb_clk,
		opb_rst => opb_rst,
		opb_abus => opb_abus,
		opb_be => opb_be,
		opb_dbus => opb_dbus,
		opb_rnw => opb_rnw,
		opb_select => opb_select,
		opb_seqaddr => opb_seqaddr,
	
		uio_dbus => uio_dbus,
		uio_errack => uio_errack,
		uio_retry => uio_retry,
		uio_toutsup => uio_toutsup,
		uio_xferack => uio_xferack,
		au_csn_n => au_csn_n,
		au_bclk => au_bclk,
		au_mclk => au_mclk,
		au_lrck => au_lrck,
		au_sdti => au_sdti,
		au_sdto0 => au_sdto0
	);


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN

	au_sdto0 <= '1';


      opb_rst<='1'; opb_clk<='0';
		wait for 20 ns;
		opb_rst<='0';
		

		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

		opb_select<='1'; opb_abus<=X"FEFE0000"; opb_dbus<=X"00000000"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

	opb_select<='1'; opb_abus<=X"FEFE0004"; opb_dbus<=X"00000000"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

		au_sdto0 <= '1';


		opb_select<='1'; opb_abus<=X"FEFE0008"; opb_dbus<=X"FFFFFFFF"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

		opb_select<='1'; opb_abus<=X"FEFE000C"; opb_dbus<=X"00F0FF00"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

		opb_select<='1'; opb_abus<=X"FEFE0010"; opb_dbus<=X"FFFFFFFF"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

		
	for i in 0 to 10 loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;



	opb_select<='1'; opb_abus<=X"FEFE0000"; opb_dbus<=X"00000000"; opb_rnw <= '0';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';

	opb_select<='1'; opb_abus<=X"FEFE0000"; opb_dbus<=X"00000000"; opb_rnw <= '1';
		while uio_xferack = '0' loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;
		opb_select<='0';
		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';







		wait for 10 ns;
		opb_clk<='1';
		wait for 10 ns;
		opb_clk<='0';



		for i in 0 to 1000000000 loop
			wait for 10 ns;
			opb_clk<='1';
			wait for 10 ns;
			opb_clk<='0';
		end loop;

   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
